
Public Interface IEmployee
  Function GetSalary() As Decimal
End Interface

Public Interface IParent
  Function HasChildren() As Boolean
End Interface

Public Interface IFriend
  Function NumberOfFriends() As Integer
End Interface

Public Class Person
  Implements IEmployee
  Implements IParent
  Implements IFriend

  Private m_dSalary As Decimal
  Private m_bChildren As Boolean
  Private m_nFriends As Integer

  Public Function Salary() As Decimal Implements IEmployee.GetSalary
    Salary = m_dSalary
  End Function

  Public Function HasChildren() As Boolean Implements IParent.HasChildren
    HasChildren = m_bChildren
  End Function

  Public Function HowManyFriends() _
  As Integer Implements IFriend.NumberOfFriends
    HowManyFriends = m_nFriends
  End Function
End Class

Module PersonUser
  Sub CheckSalary(ByVal Employee As IEmployee)
    ' Code here.. Only GetSalary() is usable for this object
  End Sub

  Sub CheckFamily(ByVal Parent As IParent)
    ' Code here.. Only HasChildren() is usable for this object
  End Sub

  Sub CheckFriends(ByVal MyFriend As IFriend)
    ' Code here.. Only NumberOfFriends() is usable for this object
  End Sub

  Sub TestPerson()
    Dim Person As Person = New Person()

    CheckSalary(Person)
    CheckFamily(Person)
    CheckFriends(Person)
  End Sub
End Module


